【Leetcode】376. Wiggle Subsequence
Description:
A sequence of numbers is called a wiggle sequence if the differences between successive numbers strictly alternate between positive and negative. The first difference (if one exists) may be either positive or negative. A sequence with fewer than two elements is trivially a wiggle sequence.
For example, [1,7,4,9,2,5]
is a wiggle sequence because the differences (6,-3,5,-7,3) are alternately positive and negative. In contrast,[1,4,7,2,5]
and [1,7,4,5,5]
are not wiggle sequences, the first because its first two differences are positive and the second because its last difference is zero.
Given a sequence of integers, return the length of the longest subsequence that is a wiggle sequence. A subsequence is obtained by deleting some number of elements (eventually, also zero) from the original sequence, leaving the remaining elements in their original order.
Examples:
Input: [1,7,4,9,2,5] Output: 6 The entire sequence is a wiggle sequence. Input: [1,17,5,10,13,15,10,5,16,8] Output: 7 There are several subsequences that achieve this length. One is [1,17,10,13,10,16,8]. Input: [1,2,3,4,5,6,7,8,9] Output: 2
I got this problem by mocking which was given 40 mins. However failed, WTF! At the begining, I concluded it was an dp problem. I was stuck in how to solve it in one loop n(O(n) timespace). then I try to figure out the trans-fomula:
dp[i][0] = max(dp[k][1] + 1, dp[i][0]); dp[i][1] = max(dp[k][0] + 1, dp[i][1]); dp[i][0] represent the longest wanted subsequence with a positive sum ending; dp[i][1] similarly but with a negative sum ending;
You must solve it in time which may sacrifice the timespace!
class Solution { public: int wiggleMaxLength(vector<int>& nums) { const int n = nums.size(); if(n == 0) return 0; int dp[n][2]; for(int i = 0; i < n; i ++){ dp[i][0] = dp[i][1] = 0; }int ans = 0; for(int i = 1; i < n; i ++){ for(int k = 0; k < i; k ++){ if(nums[i] > nums[k]){ dp[i][0] = max(dp[i][0], dp[k][1] + 1); }else if(nums[i] < nums[k]){ dp[i][1] = max(dp[i][1], dp[k][0] + 1); } } ans = max(dp[i][0], dp[i][1]); } return ans + 1; } };
Finally, I optimize the solution to O(n).
class Solution { public: int wiggleMaxLength(vector<int>& nums) { const int n = nums.size(); if(n == 0) return 0; int dp[n][2]; //dp[i][0] : Before i the longest wanted subsequence ending with a positive ending. //dp[i][1] : Before i the longest wanted subsequence ending with a negative ending. dp[0][0] = dp[0][1] = 1; for(int i = 1; i < n; i ++){ if(nums[i] > nums[i - 1]){ dp[i][0] = dp[i - 1][1] + 1; dp[i][1] = dp[i - 1][1]; }else if(nums[i] < nums[i -1]){ dp[i][1] = dp[i - 1][0] + 1; dp[i][0] = dp[i - 1][0]; }else{ dp[i][0] = dp[i - 1][0]; dp[i][1] = dp[i - 1][1]; } } return max(dp[n - 1][0], dp[n - 1][1]); } };